unit Tdt_unit;

// TimeDate(TD) utils
// version 0.9
//  by Marius BURZ 2001
// for sugestions and the like use m_burz@yahoo.com




interface
uses sysUtils;


type

  Tdt = class
  private
    f_dt: TDateTime;
  public
    constructor create(const dt: TDateTime); overload;
    constructor create(const month, day, year: word); overload;
    constructor create(const hour, minute, second, ms: word); overload;
    constructor create(const month, day, year, hour, minute: word); overload;


    procedure setDT(const dt: TDateTime);
    function  getDT: TDateTime;
    function  dAsString : shortString; //returns the date part as string
    function  tAsString : shortString; //returns the time part as string
    function  dtAsString: shortString; //returns date + time parts as string

    //result is an integer(word)
    function d: word; //returns the day
    function m: word; //returns the month
    function y: word; //returns the year

    function h   : word; //returns the hour
    function min : word; //returns the minute
    function s   : word; //returns the second
    function ms  : word; //returns the millisecond



    //result is a string
    function s_d: shortString;  //returns the day as string
    function s_m: shortString;  //returns the month as string
    function s_y: shortString;  //returns the year as string

    function s_h  : shortString;  //returns the hour as string
    function s_min: shortString;  //returns the minute as string
    function s_s  : shortString;  //returns the second as string
    function s_ms : shortString;  //returns the millisecond as string



    procedure incDay; //increase day
    procedure incDays(const days: word); //increase day with <days> days
    procedure decDay; //decrease day
    procedure decDays(const days: word); //decrease day with <days> days

    procedure incMonth;
    procedure incMonths(const months: word);
    procedure decMonth;
    procedure decMonths(const months: word);



    procedure sub(const dt: Tdt);  //substract <dt> from current date
    procedure add(const dt: Tdt);  //add <dt> to current date

    function dayOfWeek: integer; //returns day of week(1 = su ... 7 = sa)
  end;



  TdtNow = class
  public
    function  getDT: TDateTime;

    function  dAsString : shortString; //returns the date part as string
    function  tAsString : shortString; //returns the time part as string
    function  dtAsString: shortString; //returns date + time parts as string

    //result is an integer(word)
    function d: word; //returns the day
    function m: word; //returns the month
    function y: word; //returns the year

    function h   : word; //returns the hour
    function min : word; //returns the minute
    function s   : word; //returns the second
    function ms  : word; //returns the millisecond



    //result is a string
    function s_d: shortString;  //returns the day as string
    function s_m: shortString;  //returns the month as string
    function s_y: shortString;  //returns the year as string

    function s_h  : shortString;  //returns the hour as string
    function s_min: shortString;  //returns the minute as string
    function s_s  : shortString;  //returns the second as string
    function s_ms : shortString;  //returns the millisecond as string



    function incDay: Tdt; //increase day
    function incDays(const days: word): Tdt; //increase day with <days> days
    function decDay: Tdt; //decrease day
    function decDays(const days: word): Tdt; //decrease day with <days> days

    function incMonth: Tdt;
    function incMonths(const months: word): Tdt;
    function decMonth: Tdt;
    function decMonths(const months: word): Tdt;


    function sub(const dt: Tdt): Tdt;  //substract <dt> from current date
    function add(const dt: Tdt): Tdt;  //add <dt> to current date


    function dayOfWeek: integer; //returns day of week(1 = su ... 7 = sa)
  end;

var
  dtNow: TdtNow;
  
implementation




constructor Tdt.create(const dt: TDateTime);
begin
  f_dt := dt;
end;

constructor Tdt.create(const month, day, year: word);
begin
  f_dt := encodeDate(year, month, day);
end;

constructor Tdt.create(const hour, minute, second, ms: word);
begin
  f_dt := encodeTime(hour, minute, second, ms);
end;

constructor Tdt.create(const month, day, year, hour, minute: word);
begin
  f_dt := encodeDate(year, month, day);
  f_dt := f_dt + encodeTime(hour, minute, 0, 0);
end;




procedure Tdt.setDT(const dt: TDateTime);
begin
  f_dt := dt;
end;

function  Tdt.getDT: TDateTime;
begin
  result := f_dt;
end;

function  Tdt.dAsString: shortString;
begin
  result := dateToStr(f_dt);
end;

function  Tdt.tAsString: shortString;
begin
  result := timeToStr(f_dt);
end;

function  Tdt.dtAsString: shortString;
begin
  result := dateToStr(f_dt) + ' ' + timeToStr(f_dt);
end;



//==========================
//result is an integer(word)
//==========================

function Tdt.d: word;
var
  m, y: word;
begin
  decodeDate(f_dt, y, m, result);
end;

function Tdt.m: word;
var
  d, y: word;
begin
  decodeDate(f_dt, y, result, d);
end;

function Tdt.y: word;
var
  d, m: word;
begin
  decodeDate(f_dt, result, m, d);
end;



function Tdt.h: word;
var
  min, s, ms: word;
begin
  decodeTime(f_dt, result, min, s, ms);
end;

function Tdt.min: word;
var
  h, s, ms: word;
begin
  decodeTime(f_dt, h, result, s, ms);
end;

function Tdt.s: word;
var
  h, min, ms: word;
begin
  decodeTime(f_dt, h, min, result, ms);
end;

function Tdt.ms: word;
var
  h, min, s: word;
begin
  decodeTime(f_dt, h, min, s, result);
end;



//==================
//result is a string
//==================

function Tdt.s_d: shortString;
begin
  result := intToStr(d);
end;

function Tdt.s_m: shortString;
begin
  result := intToStr(m);
end;

function Tdt.s_y: shortString;
begin
  result := intToStr(y);
end;



function Tdt.s_h: shortString;
begin
  result := intToStr(h);
end;

function Tdt.s_min: shortString;
begin
  result := intToStr(min);
end;

function Tdt.s_s: shortString;
begin
  result := intToStr(s);
end;

function Tdt.s_ms: shortString;
begin
  result := intToStr(ms);
end;




procedure Tdt.incDay;
begin
  f_dt := f_dt + 1;
end;

procedure Tdt.incDays(const days: word);
begin
  f_dt := f_dt + days;
end;

procedure Tdt.decDay;
begin
  f_dt := f_dt - 1;
end;

procedure Tdt.decDays(const days: word);
begin
  f_dt := f_dt - days;
end;


procedure Tdt.incMonth;
begin
  f_dt := sysUtils.IncMonth(f_dt, 1);
end;

procedure Tdt.incMonths(const months: word);
begin
  f_dt := sysUtils.IncMonth(f_dt, months);
end;

procedure Tdt.decMonth;
begin
  f_dt := sysUtils.IncMonth(f_dt, -1);
end;

procedure Tdt.decMonths(const months: word);
begin
  f_dt := sysUtils.IncMonth(f_dt, -months);
end;



procedure Tdt.sub(const dt: Tdt);
begin
  f_dt := f_dt - dt.getDT;
end;

procedure Tdt.add(const dt: Tdt);
begin
  f_dt := f_dt + dt.getDT;
end;




function Tdt.dayOfWeek: integer;
begin
  result := sysUtils.dayOfWeek(f_dt);
end;







//==============================================================================
//  TdtNow
//==============================================================================



function  TdtNow.getDT: TDateTime;
begin
  result := now;
end;

function  TdtNow.dAsString: shortString;
begin
  result := dateToStr(now);
end;

function  TdtNow.tAsString: shortString;
begin
  result := timeToStr(now);
end;

function  TdtNow.dtAsString: shortString;
begin
  result := dateToStr(now) + ' ' + timeToStr(now);
end;



//==========================
//result is an integer(word)
//==========================

function TdtNow.d: word;
var
  m, y: word;
begin
  decodeDate(now, y, m, result);
end;

function TdtNow.m: word;
var
  d, y: word;
begin
  decodeDate(now, y, result, d);
end;

function TdtNow.y: word;
var
  d, m: word;
begin
  decodeDate(now, result, m, d);
end;



function TdtNow.h: word;
var
  min, s, ms: word;
begin
  decodeTime(now, result, min, s, ms);
end;

function TdtNow.min: word;
var
  h, s, ms: word;
begin
  decodeTime(now, h, result, s, ms);
end;

function TdtNow.s: word;
var
  h, min, ms: word;
begin
  decodeTime(now, h, min, result, ms);
end;

function TdtNow.ms: word;
var
  h, min, s: word;
begin
  decodeTime(now, h, min, s, result);
end;



//==================
//result is a string
//==================

function TdtNow.s_d: shortString;
begin
  result := intToStr(d);
end;

function TdtNow.s_m: shortString;
begin
  result := intToStr(m);
end;

function TdtNow.s_y: shortString;
begin
  result := intToStr(y);
end;



function TdtNow.s_h: shortString;
begin
  result := intToStr(h);
end;

function TdtNow.s_min: shortString;
begin
  result := intToStr(min);
end;

function TdtNow.s_s: shortString;
begin
  result := intToStr(s);
end;

function TdtNow.s_ms: shortString;
begin
  result := intToStr(ms);
end;




function TdtNow.incDay: Tdt;
begin
  result := Tdt.create(now + 1);
end;

function TdtNow.incDays(const days: word): Tdt;
begin
  result := Tdt.create(now + days);
end;

function TdtNow.decDay: Tdt;
begin
  result := Tdt.create(now - 1);
end;

function TdtNow.decDays(const days: word): Tdt;
begin
  result := Tdt.create(now - days);
end;



function TdtNow.incMonth: Tdt;
begin
  result := Tdt.create(sysUtils.incMonth(now, 1));
end;

function TdtNow.incMonths(const months: word): Tdt;
begin
  result := Tdt.create(sysUtils.incMonth(now, months));
end;

function TdtNow.decMonth: Tdt;
begin
  result := Tdt.create(sysUtils.incMonth(now, -1));
end;

function TdtNow.decMonths(const months: word): Tdt;
begin
  result := Tdt.create(sysUtils.incMonth(now, -months));
end;






function TdtNow.sub(const dt: Tdt): Tdt;
begin
  result := Tdt.create(now - dt.getDT);
end;

function TdtNow.add(const dt: Tdt): Tdt;
begin
  result := Tdt.create(now + dt.getDT);
end;




function TdtNow.dayOfWeek: integer;
begin
  result := sysUtils.dayOfWeek(now);
end;





initialization
  dtNow := TdtNow.create;

finalization
  dtNow.free;

end.
